/* scaffolding */
body {
  color: @text-color;
  background-color: @body-bg;
}
a {
  color: @link-color;
  &:hover,
  &:focus {
    color: @link-hover-color;
  }
}
.img-thumbnail {
  background-color: @thumbnail-bg;
  border-color: @thumbnail-border;
  border-radius: @thumbnail-border-radius;
}
/* type.less */
h1, h2, h3, h4, h5, h6,
.h1, .h2, .h3, .h4, .h5, .h6 {
  color: @headings-color;
  small,
  .small {
    color: @headings-small-color;
  }
}
mark,
.mark {
  background-color: @state-warning-bg;
}
.text-muted {
  color: @text-muted;
}
.text-primary {
  .text-emphasis-variant(@brand-primary);
}
.text-success {
  .text-emphasis-variant(@state-success-text);
}
.text-info {
  .text-emphasis-variant(@state-info-text);
}
.text-warning {
  .text-emphasis-variant(@state-warning-text);
}
.text-danger {
  .text-emphasis-variant(@state-danger-text);
}
.bg-primary {
  color: #fff;
  .bg-variant(@brand-primary);
}
.bg-success {
  .bg-variant(@state-success-bg);
}
.bg-info {
  .bg-variant(@state-info-bg);
}
.bg-warning {
  .bg-variant(@state-warning-bg);
}
.bg-danger {
  .bg-variant(@state-danger-bg);
}
.page-header {
  border-bottom-color: @page-header-border-color;
}
abbr[title],
abbr[data-original-title] {
  border-bottom-color: @abbr-border-color;
}
blockquote {
  border-left-color:  @blockquote-border-color;
  footer,
  small,
  .small {
    color: @blockquote-small-color;
  }
}
.blockquote-reverse,
blockquote.pull-right {
  border-right-color: @blockquote-border-color;
}
/* code.less */
code {
  color: @code-color;
  background-color: @code-bg;
}
kbd {
  color: @kbd-color;
  background-color: @kbd-bg;
}
pre {
  color: @pre-color;
  background-color: @pre-bg;
  border-color: @pre-border-color;
  code {
    color: inherit;
    white-space: pre-wrap;
    background-color: transparent;
  }
}
/* table.less */
table {
  background-color: @table-bg;
}
caption {
  color: @text-muted;
}
.table {
  > thead,
  > tbody,
  > tfoot {
    > tr {
      > th,
      > td {
        border-top-color: @table-border-color;
      }
    }
  }
  > thead > tr > th {
    border-bottom-color: @table-border-color;
  }
  > tbody + tbody {
    border-top-color: @table-border-color;
  }
  .table {
    background-color: @body-bg;
  }
}
.table-bordered {
  border-color: @table-border-color;
  > thead,
  > tbody,
  > tfoot {
    > tr {
      > th,
      > td {
        border-color: @table-border-color;
      }
    }
  }
}
.table-striped {
  > tbody > tr:nth-of-type(odd) {
    background-color: @table-bg-accent;
  }
}
.table-hover {
  > tbody > tr:hover {
    background-color: @table-bg-hover;
  }
}
.table-row-variant(active; @table-bg-active);
.table-row-variant(success; @state-success-bg);
.table-row-variant(info; @state-info-bg);
.table-row-variant(warning; @state-warning-bg);
.table-row-variant(danger; @state-danger-bg);
/* forms.less */
legend {
  color: @legend-color;
  border-bottom-color: @legend-border-color;
}
input[type="file"]:focus,
input[type="radio"]:focus,
input[type="checkbox"]:focus {
  .tab-focus();
}
output {
  color: @input-color;
}
.form-control {
  color: @input-color;
  background-color: @input-bg;
  border-color: 1px solid @input-border;
  .transition(~"border-color ease-in-out .15s, box-shadow ease-in-out .15s");
  .form-control-focus();
  .placeholder();
  &::-ms-expand {
    background-color: transparent;
  }
  &[disabled],
  &[readonly],
  fieldset[disabled] & {
    background-color: @input-bg-disabled;
  }
}
.has-success {
  .form-control-validation(@state-success-text; @state-success-text; @state-success-bg);
}
.has-warning {
  .form-control-validation(@state-warning-text; @state-warning-text; @state-warning-bg);
}
.has-error {
  .form-control-validation(@state-danger-text; @state-danger-text; @state-danger-bg);
}
.help-block {
  color: lighten(@text-color, 25%);
}

/* buttons.less */
.btn-default {
  .button-variant(@btn-default-color; @btn-default-bg; @btn-default-border);
}
.btn-primary {
  .button-variant(@btn-primary-color; @btn-primary-bg; @btn-primary-border);
}
.btn-success {
  .button-variant(@btn-success-color; @btn-success-bg; @btn-success-border);
}
.btn-info {
  .button-variant(@btn-info-color; @btn-info-bg; @btn-info-border);
}
.btn-warning {
  .button-variant(@btn-warning-color; @btn-warning-bg; @btn-warning-border);
}
.btn-danger {
  .button-variant(@btn-danger-color; @btn-danger-bg; @btn-danger-border);
}
.btn-link {
  color: @link-color;

  &,
  &:active,
  &.active,
  &[disabled],
  fieldset[disabled] & {
    background-color: transparent;
  }
  &,
  &:hover,
  &:focus,
  &:active {
    border-color: transparent;
  }
  &:hover,
  &:focus {
    color: @link-hover-color;
    background-color: transparent;
  }
  &[disabled],
  fieldset[disabled] & {
    &:hover,
    &:focus {
      color: @btn-link-disabled-color;
    }
  }
}
/* component-animations.less */
/* dropdowns.less */
.dropdown-menu {
  background-color: @dropdown-bg;
  border-color: 1px solid @dropdown-border;
  .divider {
    .nav-divider(@dropdown-divider-bg);
  }
  > li > a {
    color: @dropdown-link-color;
  }
}
.dropdown-menu > li > a {
  &:hover,
  &:focus {
    color: @dropdown-link-hover-color;
    background-color: @dropdown-link-hover-bg;
  }
}
.dropdown-menu > .active > a {
  &,
  &:hover,
  &:focus {
    color: @dropdown-link-active-color;
    background-color: @dropdown-link-active-bg;
  }
}
.dropdown-menu > .disabled > a {
  &,
  &:hover,
  &:focus {
    color: @dropdown-link-disabled-color;
  }
  &:hover,
  &:focus {
    background-color: transparent;
    background-image: none; // Remove CSS gradient
    cursor: @cursor-disabled;
  }
}
.dropdown-header {
  color: @dropdown-header-color;
}
/* button-groups.less */
/* input-groups.less */
.input-group-addon {
  color: @input-color;
  background-color: @input-group-addon-bg;
  border-color: @input-group-addon-border-color;
  border-radius: @input-border-radius;
}
/* navs.less */
.nav {


  > li {
    > a {

      &:hover,
      &:focus {
        background-color: @nav-link-hover-bg;
      }
    }

    // Disabled state sets text to gray and nukes hover/tab effects
    &.disabled > a {
      color: @nav-disabled-link-color;

      &:hover,
      &:focus {
        color: @nav-disabled-link-hover-color;
        background-color: transparent;
      }
    }
  }

  // Open dropdowns
  .open > a {
    &,
    &:hover,
    &:focus {
      background-color: @nav-link-hover-bg;
      border-color: @link-color;
    }
  }

  .nav-divider {
    .nav-divider();
  }
}
.nav-tabs {
  border-bottom: 1px solid @nav-tabs-border-color;
  > li {

    > a {
      border-color: transparent;
      &:hover {
        border-color: @nav-tabs-link-hover-border-color @nav-tabs-link-hover-border-color @nav-tabs-border-color;
      }
    }

    &.active > a {
      &,
      &:hover,
      &:focus {
        color: @nav-tabs-active-link-hover-color;
        background-color: @nav-tabs-active-link-hover-bg;
        border-color: @nav-tabs-active-link-hover-border-color;
        border-bottom-color: transparent;
      }
    }
  }
}
.nav-pills {
  > li {

    &.active > a {
      &,
      &:hover,
      &:focus {
        color: @nav-pills-active-link-hover-color;
        background-color: @nav-pills-active-link-hover-bg;
      }
    }
  }
}
.nav-tabs-justified {
  > .active > a,
  > .active > a:hover,
  > .active > a:focus {
    border-color: @nav-tabs-justified-link-border-color;
  }

  @media (min-width: @screen-sm-min) {
    > li > a {
      border-bottom-color: @nav-tabs-justified-link-border-color;
    }
    > .active > a,
    > .active > a:hover,
    > .active > a:focus {
      border-bottom-color: @nav-tabs-justified-active-link-border-color;
    }
  }
}
/* navbar.less */
.navbar {
  border-color: transparent;
}
.navbar-collapse {
  border-top-color: transparent;
}
.navbar-toggle {
  background-color: transparent;
  border-color:transparent;
}
.navbar-nav {
  @media (max-width: @grid-float-breakpoint-max) {
    .open .dropdown-menu {
      background-color: transparent;
    }
  }
}
/* breadcrumbs.less */
.breadcrumb {
  background-color: @breadcrumb-bg;
  > li {
    + li:before {
      color: @breadcrumb-color;
    }
  }
  > .active {
    color: @breadcrumb-active-color;
  }
}
/* pagination.less */
.pagination {

  > li {
    > a,
    > span {
      color: @pagination-color;
      background-color: @pagination-bg;
      border-color: @pagination-border;
    }
  }

  > li > a,
  > li > span {
    &:hover,
    &:focus {
      color: @pagination-hover-color;
      background-color: @pagination-hover-bg;
      border-color: @pagination-hover-border;
    }
  }

  > .active > a,
  > .active > span {
    &,
    &:hover,
    &:focus {
      color: @pagination-active-color;
      background-color: @pagination-active-bg;
      border-color: @pagination-active-border;
    }
  }

  > .disabled {
    > span,
    > span:hover,
    > span:focus,
    > a,
    > a:hover,
    > a:focus {
      color: @pagination-disabled-color;
      background-color: @pagination-disabled-bg;
      border-color: @pagination-disabled-border;
    }
  }
}
/* pager.less */
.pager {
  li {
    display: inline;
    > a,
    > span {
      background-color: @pager-bg;
      border-color: @pager-border;
    }

    > a:hover,
    > a:focus {
      background-color: @pager-hover-bg;
    }
  }

  .disabled {
    > a,
    > a:hover,
    > a:focus,
    > span {
      color: @pager-disabled-color;
      background-color: @pager-bg;
    }
  }
}
/* labels.less */
.label {
  color: @label-color;

  a& {
    &:hover,
    &:focus {
      color: @label-link-hover-color;
    }
  }
}
.label-default {
  .label-variant(@label-default-bg);
}

.label-primary {
  .label-variant(@label-primary-bg);
}

.label-success {
  .label-variant(@label-success-bg);
}

.label-info {
  .label-variant(@label-info-bg);
}

.label-warning {
  .label-variant(@label-warning-bg);
}

.label-danger {
  .label-variant(@label-danger-bg);
}
/* badges.less */
.badge {
  color: @badge-color;
  background-color: @badge-bg;

  a& {
    &:hover,
    &:focus {
      color: @badge-link-hover-color;
    }
  }

  .list-group-item.active > &,
  .nav-pills > .active > a > & {
    color: @badge-active-color;
    background-color: @badge-active-bg;
  }
}
/* jumbotron.less */
.jumbotron {
  color: @jumbotron-color;
  background-color: @jumbotron-bg;

  h1,
  .h1 {
    color: @jumbotron-heading-color;
  }
  > hr {
    border-top-color: darken(@jumbotron-bg, 10%);
  }
}
/* thumbnails.less */
.thumbnail {
  background-color: @thumbnail-bg;
  border: 1px solid @thumbnail-border;

  a&:hover,
  a&:focus,
  a&.active {
    border-color: @link-color;
  }

  .caption {
    color: @thumbnail-caption-color;
  }
}
/* alerts.less */
.alert-success {
  .alert-variant(@alert-success-bg; @alert-success-border; @alert-success-text);
}

.alert-info {
  .alert-variant(@alert-info-bg; @alert-info-border; @alert-info-text);
}

.alert-warning {
  .alert-variant(@alert-warning-bg; @alert-warning-border; @alert-warning-text);
}

.alert-danger {
  .alert-variant(@alert-danger-bg; @alert-danger-border; @alert-danger-text);
}
/* progress-bars.less */
.progress {
  background-color: @progress-bg;
}
.progress-bar {
  color: @progress-bar-color;
  background-color: @progress-bar-bg;
}
.progress-striped .progress-bar,
.progress-bar-striped {
  #gradient > .striped();
}
.progress-bar-success {
  .progress-bar-variant(@progress-bar-success-bg);
}

.progress-bar-info {
  .progress-bar-variant(@progress-bar-info-bg);
}

.progress-bar-warning {
  .progress-bar-variant(@progress-bar-warning-bg);
}

.progress-bar-danger {
  .progress-bar-variant(@progress-bar-danger-bg);
}
/* media.less */
/* list-group.less */
.list-group-item {
  background-color: @list-group-bg;
  border-color: @list-group-border;
}
a.list-group-item,
button.list-group-item {
  color: @list-group-link-color;
  .list-group-item-heading {
    color: @list-group-link-heading-color;
  }
  &:hover,
  &:focus {
    color: @list-group-link-hover-color;
    background-color: @list-group-hover-bg;
  }
}
.list-group-item {
  &.disabled,
  &.disabled:hover,
  &.disabled:focus {
    background-color: @list-group-disabled-bg;
    color: @list-group-disabled-color;
    .list-group-item-heading {
      color: inherit;
    }
    .list-group-item-text {
      color: @list-group-disabled-text-color;
    }
  }

  &.active,
  &.active:hover,
  &.active:focus {
    color: @list-group-active-color;
    background-color: @list-group-active-bg;
    border-color: @list-group-active-border;

    .list-group-item-heading,
    .list-group-item-heading > small,
    .list-group-item-heading > .small {
      color: inherit;
    }
    .list-group-item-text {
      color: @list-group-active-text-color;
    }
  }
}
.list-group-item-variant(success; @state-success-bg; @state-success-text);
.list-group-item-variant(info; @state-info-bg; @state-info-text);
.list-group-item-variant(warning; @state-warning-bg; @state-warning-text);
.list-group-item-variant(danger; @state-danger-bg; @state-danger-text);
/* panels.less */
.panel {
  border-color: transparent;
}
.panel-footer {
  background-color: @panel-footer-bg;
  border-top-color: @panel-inner-border;
}
.panel {

  > .panel-body + .table,
  > .panel-body + .table-responsive,
  > .table + .panel-body,
  > .table-responsive + .panel-body {
    border-top-color: @table-border-color;
  }
}
.panel-group {

  .panel-heading {
    + .panel-collapse > .panel-body,
    + .panel-collapse > .list-group {
      border-top-color: @panel-inner-border;
    }
  }

  .panel-footer {
    border-top: 0;
    + .panel-collapse .panel-body {
      border-bottom-color: @panel-inner-border;
    }
  }
}
.panel-default {
  .panel-variant(@panel-default-border; @panel-default-text; @panel-default-heading-bg; @panel-default-border);
}
.panel-primary {
  .panel-variant(@panel-primary-border; @panel-primary-text; @panel-primary-heading-bg; @panel-primary-border);
}
.panel-success {
  .panel-variant(@panel-success-border; @panel-success-text; @panel-success-heading-bg; @panel-success-border);
}
.panel-info {
  .panel-variant(@panel-info-border; @panel-info-text; @panel-info-heading-bg; @panel-info-border);
}
.panel-warning {
  .panel-variant(@panel-warning-border; @panel-warning-text; @panel-warning-heading-bg; @panel-warning-border);
}
.panel-danger {
  .panel-variant(@panel-danger-border; @panel-danger-text; @panel-danger-heading-bg; @panel-danger-border);
}
/* responsive-embed.less */
/* wells.less */
.well {
  background-color: @well-bg;
  border-color: @well-border;
  blockquote {
    border-color: #ddd;
    border-color: rgba(0,0,0,.15);
  }
}
/* close.less */
.close {
  color: @close-color;
  text-shadow: @close-text-shadow;

  &:hover,
  &:focus {
    color: @close-color;
  }

}
/* modals.less */
.modal-content {
  background-color: @modal-content-bg;
  border-color: @modal-content-border-color;
}
.modal-backdrop {
  background-color: @modal-backdrop-bg;
}
.modal-header {
  border-bottom-color: @modal-header-border-color;
}
.modal-footer {
  border-top-color: 1px solid @modal-footer-border-color;
}
/* tooltip.less */
.tooltip-inner {
  color: @tooltip-color;
  background-color: @tooltip-bg;
}
.tooltip {
  &.top .tooltip-arrow {
    border-top-color: @tooltip-arrow-color;
  }
  &.top-left .tooltip-arrow {
    border-top-color: @tooltip-arrow-color;
  }
  &.top-right .tooltip-arrow {
    border-top-color: @tooltip-arrow-color;
  }
  &.right .tooltip-arrow {
    border-right-color: @tooltip-arrow-color;
  }
  &.left .tooltip-arrow {
    border-left-color: @tooltip-arrow-color;
  }
  &.bottom .tooltip-arrow {
    border-bottom-color: @tooltip-arrow-color;
  }
  &.bottom-left .tooltip-arrow {
    border-bottom-color: @tooltip-arrow-color;
  }
  &.bottom-right .tooltip-arrow {
    border-bottom-color: @tooltip-arrow-color;
  }
}
/* popovers.less */
.popover {
  background-color: @popover-bg;
  border-color: 1px solid @popover-border-color;
}
.popover-title {
  background-color: @popover-title-bg;
  border-bottom-color: darken(@popover-title-bg, 5%);
}
.popover > .arrow {
  &,
  &:after {
    border-color: transparent;
  }
}
.popover {
  &.top > .arrow {
    border-top-color: @popover-arrow-outer-color;
    bottom: -@popover-arrow-outer-width;
    &:after {
      border-top-color: @popover-arrow-color;
    }
  }
  &.right > .arrow {
    border-right-color: @popover-arrow-outer-color;
    &:after {
      border-right-color: @popover-arrow-color;
    }
  }
  &.bottom > .arrow {
    border-bottom-color: @popover-arrow-outer-color;
    top: -@popover-arrow-outer-width;
    &:after {
      border-bottom-color: @popover-arrow-color;
    }
  }

  &.left > .arrow {
    border-left-color: @popover-arrow-outer-color;
    &:after {
      border-left-color: @popover-arrow-color;
    }
  }
}
/* carousel.less */
.carousel-control {
  color: @carousel-control-color;
  text-shadow: @carousel-text-shadow;

  // Hover/focus state
  &:hover,
  &:focus {
    color: @carousel-control-color;
  }
}
/* utilities.less */
/* responsive-utilities.less */
